Index: /trunk/LMDZ.COMMON/libf/evolution/orbit_param_criterion_mod.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/orbit_param_criterion_mod.F90	(revision 3075)
+++ /trunk/LMDZ.COMMON/libf/evolution/orbit_param_criterion_mod.F90	(revision 3076)
@@ -3,5 +3,5 @@
 !=======================================================================
 !
-! Purpose: Compute the maximum number of iteration for PEM based on the 
+! Purpose: Compute the maximum number of iteration for PEM based on the
 ! stopping criterion given by the orbital parameters
 !
@@ -9,7 +9,9 @@
 !=======================================================================
 
-IMPLICIT NONE
-
-CONTAINS
+implicit none
+
+!=======================================================================
+contains
+!=======================================================================
 
 SUBROUTINE orbit_param_criterion(i_myear,year_iter_max)
@@ -26,33 +28,33 @@
     use planete_mod, only: e_elips, obliquit, lsperi
 #endif
-  use time_evol_mod,  only: year_bp_ini, var_obl, var_ecc, var_lsp, convert_years
-  use comconst_mod,   only: pi
-  use lask_param_mod, only: yearlask, obllask, ecclask, lsplask, ini_lask_param_mod, last_ilask
-
-  IMPLICIT NONE
+use time_evol_mod,  only: year_bp_ini, var_obl, var_ecc, var_lsp, convert_years
+use comconst_mod,   only: pi
+use lask_param_mod, only: yearlask, obllask, ecclask, lsplask, ini_lask_param_mod, last_ilask
+
+implicit none
 
 !--------------------------------------------------------
 ! Input Variables
 !--------------------------------------------------------
-  integer, intent(in) :: i_myear ! Martian year of the simulation
+integer, intent(in) :: i_myear ! Martian year of the simulation
 
 !--------------------------------------------------------
 ! Output Variables
 !--------------------------------------------------------
-  integer, intent(out) :: year_iter_max ! Maximum number of iteration of the PEM before orb changes too much
-
-!--------------------------------------------------------
-! Local variables 
-!--------------------------------------------------------
-  integer :: Year                                           ! Year of the simulation
-  real    :: Lsp                                            ! Ls perihelion
-  real    :: max_change_obl, max_change_ecc, max_change_lsp ! Maximum admissible change
-  real    :: max_obl, max_ecc, max_lsp                      ! Maximum value of orbit param given the admissible change
-  real    :: min_obl, min_ecc, min_lsp                      ! Minimum value of orbit param given the admissible change
-  integer :: max_obl_iter, max_ecc_iter, max_lsp_iter       ! Maximum year iteration before reaching an inadmissible value of orbit param
-  integer :: ilask, iylask                                  ! Loop variables
-  real    :: xa, xb, ya, yb                                 ! Variables for interpolation
-  logical :: found_obl, found_ecc, found_lsp                ! Flag variables for orbital parameters
-  logical :: crossed_modulo_d, crossed_modulo_i             ! Flag variables for modulo of Lsp
+integer, intent(out) :: year_iter_max ! Maximum number of iteration of the PEM before orb changes too much
+
+!--------------------------------------------------------
+! Local variables
+!--------------------------------------------------------
+integer :: Year                                           ! Year of the simulation
+real    :: Lsp                                            ! Ls perihelion
+real    :: max_change_obl, max_change_ecc, max_change_lsp ! Maximum admissible change
+real    :: max_obl, max_ecc, max_lsp                      ! Maximum value of orbit param given the admissible change
+real    :: min_obl, min_ecc, min_lsp                      ! Minimum value of orbit param given the admissible change
+integer :: max_obl_iter, max_ecc_iter, max_lsp_iter       ! Maximum year iteration before reaching an inadmissible value of orbit param
+integer :: ilask, iylask                                  ! Loop variables
+real    :: xa, xb, ya, yb                                 ! Variables for interpolation
+logical :: found_obl, found_ecc, found_lsp                ! Flag variables for orbital parameters
+logical :: crossed_modulo_d, crossed_modulo_i             ! Flag variables for modulo of Lsp
 
 ! **********************************************************************
@@ -84,5 +86,5 @@
 endif
 
-! Constant max change case 
+! Constant max change case
 max_change_obl = 0.6
 max_change_ecc = 2.8e-3
@@ -106,5 +108,5 @@
 write(*,*) 'Maximum Lsp accepted =', max_lsp
 write(*,*) 'Minimum Lsp accepted =', min_lsp
-! End Constant max change case 
+! End Constant max change case
 
 ! If we do not want some orb parameter to change, they should not be a stopping criterion,
@@ -175,5 +177,5 @@
             endif
         else
-            if (crossed_modulo_d) then ! If decreasing Lsp "crossed" the modulo but min_lsp has not been met yet 
+            if (crossed_modulo_d) then ! If decreasing Lsp "crossed" the modulo but min_lsp has not been met yet
                 ya = ya - 360.
                 yb = yb - 360.
@@ -208,5 +210,5 @@
 END SUBROUTINE orbit_param_criterion
 
-!********************************************************************************   
+!***********************************************************************
 
 END MODULE orbit_param_criterion_mod
Index: /trunk/LMDZ.COMMON/libf/evolution/pem.F90
===================================================================
--- /trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 3075)
+++ /trunk/LMDZ.COMMON/libf/evolution/pem.F90	(revision 3076)
@@ -27,36 +27,46 @@
 PROGRAM pem
 
-use phyetat0_mod,               only: phyetat0
-use phyredem,                   only: physdem0, physdem1
-use netcdf,                     only: nf90_open, NF90_NOWRITE, nf90_get_var, nf90_inq_varid, nf90_close
-use turb_mod,                   only: q2, wstar
-use comslope_mod,               only: nslope, def_slope, def_slope_mean, subslope_dist, iflat, major_slope, ini_comslope_h
-use logic_mod,                  only: iflag_phys
-use mod_const_mpi,              only: COMM_LMDZ
+use phyetat0_mod,                 only: phyetat0
+use phyredem,                     only: physdem0, physdem1
+use netcdf,                       only: nf90_open, NF90_NOWRITE, nf90_get_var, nf90_inq_varid, nf90_close
+use turb_mod,                     only: q2, wstar
+use comslope_mod,                 only: nslope, def_slope, def_slope_mean, subslope_dist, iflat, major_slope, ini_comslope_h
+use logic_mod,                    only: iflag_phys
+use mod_const_mpi,                only: COMM_LMDZ
 use infotrac
-use geometry_mod,               only: latitude_deg
-use conf_pem_mod,               only: conf_pem
-use pemredem,                   only: pemdem0, pemdem1
-use glaciers_mod,               only: co2glaciers_evol, h2oglaciers_evol, co2glaciersflow, h2oglaciersflow
-use criterion_pem_stop_mod,     only: criterion_waterice_stop, criterion_co2_stop
-use constants_marspem_mod,      only: alpha_clap_co2, beta_clap_co2, alpha_clap_h2o, beta_clap_h2o, m_co2, &
-                                      m_noco2, threshold_water_frost2perenial, threshold_co2_frost2perenial
-use evol_co2_ice_s_mod,         only: evol_co2_ice_s
-use evol_h2o_ice_s_mod,         only: evol_h2o_ice_s
-use comsoil_h_PEM,              only: soil_pem, ini_comsoil_h_PEM, end_comsoil_h_PEM, nsoilmx_PEM, &
-                                      TI_PEM, inertiedat_PEM,           & ! soil thermal inertia
-                                      tsoil_PEM, mlayer_PEM, layer_PEM, & ! Soil temp, number of subsurface layers, soil mid layer depths
-                                      fluxgeo,                          & ! Geothermal flux for the PEM and GCM
-                                      water_reservoir                     ! Water ressources
-use adsorption_mod,             only: regolith_adsorption, adsorption_pem,        & ! Bool to check if adsorption, main subroutine
-                                      ini_adsorption_h_PEM, end_adsorption_h_PEM, & ! Allocate arrays
-                                      co2_adsorbded_phys, h2o_adsorbded_phys        ! Mass of co2 and h2O adsorbded
-use time_evol_mod,              only: dt_pem, evol_orbit_pem, Max_iter_pem, convert_years, year_bp_ini
-use orbit_param_criterion_mod,  only: orbit_param_criterion
-use recomp_orb_param_mod,       only: recomp_orb_param
-use ice_table_mod,              only: porefillingice_depth, porefillingice_thickness, end_ice_table_porefilling, &
-                                      ini_ice_table_porefilling, computeice_table_equilibrium,compute_massh2o_exchange_ssi
-use soil_thermalproperties_mod, only: update_soil_thermalproperties
-use time_phylmdz_mod,           only: daysec, dtphys, day_end
+use geometry_mod,                 only: latitude_deg
+use conf_pem_mod,                 only: conf_pem
+use pemredem,                     only: pemdem0, pemdem1
+use glaciers_mod,                 only: co2glaciers_evol, h2oglaciers_evol, co2glaciersflow, h2oglaciersflow
+use criterion_pem_stop_mod,       only: criterion_waterice_stop, criterion_co2_stop
+use constants_marspem_mod,        only: alpha_clap_co2, beta_clap_co2, alpha_clap_h2o, beta_clap_h2o, m_co2, &
+                                        m_noco2, threshold_water_frost2perenial, threshold_co2_frost2perenial
+use evol_co2_ice_s_mod,           only: evol_co2_ice_s
+use evol_h2o_ice_s_mod,           only: evol_h2o_ice_s
+use comsoil_h_PEM,                only: soil_pem, ini_comsoil_h_PEM, end_comsoil_h_PEM, nsoilmx_PEM, &
+                                        TI_PEM, inertiedat_PEM,           & ! soil thermal inertia
+                                        tsoil_PEM, mlayer_PEM, layer_PEM, & ! Soil temp, number of subsurface layers, soil mid layer depths
+                                        fluxgeo,                          & ! Geothermal flux for the PEM and GCM
+                                        water_reservoir                     ! Water ressources
+use adsorption_mod,               only: regolith_adsorption, adsorption_pem,        & ! Bool to check if adsorption, main subroutine
+                                        ini_adsorption_h_PEM, end_adsorption_h_PEM, & ! Allocate arrays
+                                        co2_adsorbded_phys, h2o_adsorbded_phys        ! Mass of co2 and h2O adsorbded
+use time_evol_mod,                only: dt_pem, evol_orbit_pem, Max_iter_pem, convert_years, year_bp_ini
+use orbit_param_criterion_mod,    only: orbit_param_criterion
+use recomp_orb_param_mod,         only: recomp_orb_param
+use ice_table_mod,                only: porefillingice_depth, porefillingice_thickness, end_ice_table_porefilling, &
+                                        ini_ice_table_porefilling, computeice_table_equilibrium,compute_massh2o_exchange_ssi
+use soil_thermalproperties_mod,   only: update_soil_thermalproperties
+use time_phylmdz_mod,             only: daysec, dtphys, day_end
+use abort_pem_mod,                only: abort_pem
+use soil_settings_PEM_mod,        only: soil_settings_PEM
+use compute_tendencies_slope_mod, only: compute_tendencies_slope
+use info_run_PEM_mod,             only: info_run_PEM
+use interpolate_TIPEM_TIGCM_mod,  only: interpolate_TIPEM_TIGCM
+use nb_time_step_GCM_mod,         only: nb_time_step_GCM
+use pemetat0_mod,                 only: pemetat0
+use read_data_GCM_mod,            only: read_data_GCM
+use recomp_tend_co2_slope_mod,    only: recomp_tend_co2_slope
+use soil_pem_compute_mod,         only: soil_pem_compute
 
 #ifndef CPP_STD
@@ -85,13 +95,10 @@
 
 #ifndef CPP_1D
-    use iniphysiq_mod,    only: iniphysiq
-    use control_mod,      only: iphysiq, day_step, nsplit_phys
-    use comconst_mod,     only: rad, g, cpp, pi
+    use iniphysiq_mod,            only: iniphysiq
+    use control_mod,              only: iphysiq, day_step, nsplit_phys
+    use comconst_mod,             only: rad, g, cpp, pi
 #else
-    use time_phylmdz_mod, only: iphysiq, day_step
-    use comcstfi_h,       only: pi, rad, g, cpp
-#endif
-
-#ifdef CPP_1D
+    use time_phylmdz_mod,         only: iphysiq, day_step
+    use comcstfi_h,               only: pi, rad, g, cpp
     use regular_lonlat_mod,       only: init_regular_lonlat
     use physics_distribution_mod, only: init_physics_distribution
@@ -99,7 +106,8 @@
     use init_testphys1d_mod,      only: init_testphys1d
     use comvert_mod,              only: ap, bp
+    use writerestart1D_mod,       only: writerestart1D
 #endif
 
-IMPLICIT NONE
+implicit none
 
 include "dimensions.h"
@@ -858,6 +866,6 @@
                 Tsoil_locslope(:,:) = tsoil_phys_PEM_timeseries(:,:,islope,t)
                 Tsurf_locslope(:) = tsurf_GCM_timeseries(:,islope,t)
-                call soil_pem_routine(ngrid,nsoilmx_PEM,.true.,TI_locslope,timestep/timelen,Tsurf_locslope,Tsoil_locslope)
-                call soil_pem_routine(ngrid,nsoilmx_PEM,.false.,TI_locslope,timestep/timelen,Tsurf_locslope,Tsoil_locslope)
+                call soil_pem_compute(ngrid,nsoilmx_PEM,.true.,TI_locslope,timestep/timelen,Tsurf_locslope,Tsoil_locslope)
+                call soil_pem_compute(ngrid,nsoilmx_PEM,.false.,TI_locslope,timestep/timelen,Tsurf_locslope,Tsoil_locslope)
                 tsoil_phys_PEM_timeseries(:,:,islope,t) = Tsoil_locslope(:,:)
                 do ig = 1,ngrid
@@ -916,6 +924,6 @@
 !------------------------
     write(*,*) "Adaptation of the new co2 tendencies to the current pressure"
-    call recomp_tend_co2_slope(tendencies_co2_ice,tendencies_co2_ice_ini,qsurf(:,igcm_co2,:),vmr_co2_gcm,vmr_co2_pem_phys,ps_timeseries, &
-                               global_ave_press_GCM,global_ave_press_new,timelen,ngrid,nslope)
+    call recomp_tend_co2_slope(ngrid,nslope,timelen,tendencies_co2_ice,tendencies_co2_ice_ini,qsurf(:,igcm_co2,:),emis,vmr_co2_gcm,vmr_co2_pem_phys,ps_timeseries, &
+                               global_ave_press_GCM,global_ave_press_new)
 
 !------------------------
